//---------------------------------------------------------------------------

#include <vcl.h>
#include <Printers.hpp>
#pragma hdrstop

#define TECIT_DLLIMPORT
#define TECIT_NOTRACE
#define TECIT_NOTOOLS

#include "TBarCode.h"
#include "Borland_DLL_Sample.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

t_BarCode* pBC;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
ERRCODE CustomizeBarcode()
{
        ERRCODE  eCode = ErrOk;
        LOGFONT* lf    = NULL;                  // used to change font of barcode

        eCode = BCSetBCType (pBC, eBC_3OF9);    // set the barcode type to Code39
                                                // --> refer to TECBCEnum.h (or the documentation)
        if (eCode == ErrOk)
        {
                eCode = BCSetText(pBC, "HELLO WORLD", 0);   // set the barcode data to "HELLO WORLD" (use caps for Code39!!)

                // Insert this code lines if you want to change the font:
                // lf = BCGetLogFont(pBC);
                // lf->lfHeight = 16;
                // strcpy(lf->lfFaceName, "Tahoma");    // face name must not exceed 31 characters

                // Use this commands if you want to change the module width:
                // BCSetModWidth (pBC, "254");	        // Set module width to 0.254 mms
        }

        if (eCode == ErrOk)
                eCode = BCCreate(pBC);      // prepare the internal barcode info-structure to be drawn

        return eCode;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        ERRCODE  eCode = ErrOk;

        // License at startup of your application
        // get your license key from http://www.tec-it.com/order/
        // BCLicenseMe( "Licensee String", eKindOfLicense, 1, "Your Key", eProductID);
        // for enums refer to  TECBCEnum.h

        BCAlloc (&pBC);                     // alloate memory for internal barcode structure

        eCode = CustomizeBarcode ();        // set barcode type, encoding data, etc.

        // draw barcode to image canvas on form
        if (eCode == ErrOk)
        {
        TRect rImg;
                SetRect(&rImg, Image1->ClientRect.left, Image1->ClientRect.top, Image1->ClientRect.right, Image1->ClientRect.bottom); // Client Rect in Pixel
                BCDraw(pBC, Image1->Canvas->Handle, &rImg); //draws the barcode into the defined image rectangle
                Image1->Refresh();
        }

        // print barcode
        if (eCode == ErrOk)
        {
                TPrinter* Prntr = Printer(); // get an instance of the printer object for printing to the standard printer
                Prntr->BeginDoc();

                RECT r;                      //to print the barcode, a rectangle must be defined
                r.left  = Prntr->PageWidth/3;
                r.top   = Prntr->PageHeight/4;
                r.right = Prntr->PageWidth - Prntr->PageWidth/3;
                r.bottom= Prntr->PageHeight/4 + Prntr->PageHeight/5;

                // sample calls to get height or width (in mms or Pixel)
                // dHeight_mm 	= BCGetBarcodeHeight(pBC, pRect, Prntr.Handle, eMUMM); // get height in mm
                // dWidth_Pixel = BCGetBarcodeWidth(pBC, pRect, Prntr.Handle, eMUPixel);  // get width in Pixel

                BCDraw(pBC, Prntr->Handle, &r);   //prints the barcode into the defined rectangle
                Prntr->EndDoc();
        }
        else
        {
                // if an error occured display more info about the error
                char szText[32] = {0};
                //ZeroMemory(szText, sizeof(szText));
                BCGetErrorText(eCode, szText, sizeof(szText));
                MessageBox(NULL, szText, "Error creating barcode:", MB_OK);
        }

        BCFree(pBC);            // frees the allocated memory of the barcode
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button2Click(TObject *Sender)
{
        ERRCODE eCode   = ErrOk;
        VOID*   pBuffer = NULL;
        INT     nSize;
        INT     nWidth;

        BCAlloc (&pBC);                     // alloate memory for internal barcode structure

        eCode = CustomizeBarcode ();        // set barcode type, encoding data, etc.

        // draw barcode to image canvas on form
        if (eCode == ErrOk)
        {
        TRect rImg;
                SetRect(&rImg, Image1->ClientRect.left, Image1->ClientRect.top, Image1->ClientRect.right, Image1->ClientRect.bottom); // Client Rect in Pixel
                BCDraw(pBC, Image1->Canvas->Handle, &rImg); //draws the barcode into the defined image rectangle
                Image1->Refresh();
        }

        // create new stream object
        TMemoryStream* pms = new TMemoryStream();

        // adjust image witdh to number of bars/spaces
        // (use integral numbers for scaling only! --> no aliasing problems! --> best readability!)
        nWidth = 2 * BCGetCountModules (pBC);

        // create BMP in Buffer
        eCode = BCSaveImageToBufferEx (pBC, NULL, (unsigned char **) &pBuffer, eIMBmp, 0, nWidth, 100, 96, 96);

        if (eCode == ErrOk)
        {
                // get size of bmp in memory
                nSize = GlobalSize((HGLOBAL)GlobalHandle(pBuffer));

                // set size of stream object
                pms->SetSize(nSize);

                // write memory to stream object
                pms->WriteBuffer (pBuffer, nSize);

                // now here comes the destination object: TBitmap
                Graphics::TBitmap *pBitmap = new Graphics::TBitmap();

                pms->Position = 0;
                pBitmap->LoadFromStream(pms);  // transfer to Bitmap object (from stream)

                // and finally write the bitmap to a file
                pBitmap->SaveToFile("c:\\barcode.bmp");
        }

        // Free memory!
        if (pBuffer != NULL)
                GlobalFree (pBuffer);

        BCFree(pBC);            // frees the allocated memory of the barcode
}
//---------------------------------------------------------------------------

